%Lagrange interpolation test.
%
%Rate converts blocks of inputs to outputs.  The input block size is fixed but the output
%block size varies depending on how many outputs can be produced from the inputs.

% K - lagrange filter order (K+1 tap filter)
K = 5;

% dt = output time step (relative to the input time step which is always assumed to be 1)
dt = .987;

% Nx = block size for processing
Nx = 123;

% initial conditions
x0 = zeros(1,K);
t0 = 0;
tx = [0];

% for some number of blocks...
for i=1:25,
  % get the input samples
  tx = tx(length(tx))+[1:Nx];
  x = sin(tx/211*7*2*pi);

  % rate convert the inputs
  [y t Ny t0 x0] = asrc_lagrange(x,dt,t0,x0,K);

  % fyi print output block size
  Ny

  % plot input and output data
  plot([1:Nx],x);
  hold on;
  plot(t,y,'.r');
  hold off;
  pause;
end;